///////////////////////////////////////////////////////////////////////////////
// SDDRIVE_VIDEO_GENERATION.C  Preparation fichier .sd pour video avec sddrive
///////////////////////////////////////////////////////////////////////////////


#include <stdlib.h>
#include <stdio.h>
#include <string.h>

FILE *fbin;
FILE *fraw;
char ecran[8000];  //ecran Thomson
char cible[8000];  //image a afficher

//Chargement d'un fichier .bmp ///////////////////////////////////////////////
void Loadbmp(char *name, int frame)
{
 FILE *fbmp;
 char filename[256];
 sprintf(filename, "_generation\\%s\\%04i.bmp", name, frame);
 printf("frame %s ", filename);
 fbmp = fopen(filename, "rb");
 if(fbmp == NULL) printf("Erreur d'ouverture");
 fseek(fbmp, 0x3e, SEEK_SET);
 fread(cible, 8000, 1, fbmp);
 fclose(fbmp);
 printf("\n");
}

//Generation d'un fichier video //////////////////////////////////////////////
void Video(char *name, int maxframe)
{
 int i;     //indice de boucle
 int time;  //temps ecoule depuis le debut de la video
 int frame; //numero de l'image en cours de traitement
 int index; //index dans l'ecran Thomson
 int saut;  //nombre d'octets non modifies
 int octet; //numero d'octet dans le bloc
 int son;   //echantillon de son sur 6 bits
 char filename[256];

 //initialisations
 sprintf(filename, "_generation\\%s.bin", name);
 fbin = fopen(filename, "wb");      //fichier video pour sddrive_video
 strcpy(filename, name);
 sprintf(filename, "_generation\\%s.raw", name);
 fraw = fopen(filename, "rb");      //fichier son en entree
 time = frame = saut = octet = 0;
 for(i = 0; i < 8000; i++) ecran[i] = cible[i] = 0;
 index = -1;

 //boucle de conversion
 while(frame < maxframe)            //pour toutes les images de la video
 {
  index++;
  if(index == 8000) index = 0;      //retour en debut d'ecran
  saut++;
  if(ecran[index] == cible[index])  //pas de difference
  if(saut < 255) continue;          //si le saut est <255 ne rien faire
  son = fgetc(fraw);                //lecture echantillon son
  fputc(son, fbin);                 //ecriture echantillon son
  fputc(saut, fbin);                //ecrire le saut dans le fichier
  fputc(cible[index], fbin);        //ecrire le nouvel octet dans le fichier
  ecran[index] = cible[index];      //mettre a jour la valeur de l'ecran
  saut = 0;                         //remettre le saut a zero
  octet += 3;                       //compteur d'octets dans le bloc
  if(octet == 510)                  //deux derniers octets du bloc
  {
   son = fgetc(fraw);                //lecture echantillon son
   fputc(son, fbin);                 //ecriture echantillon son
   son = fgetc(fraw);                //lecture echantillon son
   fputc(son, fbin);                 //ecriture echantillon son
   octet = 0;                        //raz compteur d'octets
   time += 33321;                    //temps ecoul en cycles
   if(time > 40000 * frame) Loadbmp(name, ++frame);  //nouvelle image
  }
 }

 //ajout de deux octets de fin et fermeture des fichiers
 fputc(0, fbin);  //indicateur de fin de video
 fputc(0, fbin);  //octet inutilise
 fclose(fraw);
 fclose(fbin);
}

///////////////////////////////////////////////////////////////////////////////
// Programme principal
///////////////////////////////////////////////////////////////////////////////
int main()
{
 Video("cat", 1810);  //nom du fichier et nombre d'images
 Video("barbara", 4483);  //nom du fichier et nombre d'images
 system("pause");
 return 0;
}
